#rh26
%define name	libgcj
%define version	2.96
%define release	4mdk

%{expand: %%{global} _gcc_is_%{_target_cpu} %%{nil}}
%{?_gcc_is_sparc: %global gcc_target_platform sparc64-redhat-linux}
%{!?_gcc_is_sparc: %global gcc_target_platform %{_target_platform}}

Summary:	Java runtime library for gcc
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Libraries
URL:		http://sourceware.cygnus.com/java/
Source:		libgcj-%{version}.tar.bz2
Patch1:		libgcj-makej.patch.bz2
Patch2:		libgcj-nomultilib.patch.bz2
Patch3:		libgcj-compile.patch.bz2
Patch4:		libgcj-awt-color.patch.bz2
Patch5:		libgcj-sigaction.patch.bz2
Patch6:		libgcj-boehmgc.patch.bz2
Patch7:		libgcj-libdeps.patch.bz2
BuildRoot:	%{_tmppath}/libgcj-root
BuildRequires:	gcc-java >= 2.96-0.60mdk
BuildRequires:	gcc-c++ >= 2.96-0.60mdk
BuildRequires:	zlib-devel
Requires:	zip >= 2.1
Obsoletes:	gcc-libgcj
Prereq:		/sbin/install-info
ExcludeArch:	ia64 ppc

%description
The Java runtime library. You will need this package to run your Java
programs compiled using the gcc Java compiler (gcj).

%package devel
Summary: Libraries for Java development using gcc
Group: Development/C
URL: http://sourceware.cygnus.com/java/
Requires: zip >= 2.1, libgcj = %{version}

%description devel
The Java static libraries and C header files. You will need this
package to compile your Java programs using the gcc Java compiler (gcj).

%prep
%setup -q -n libgcj
%patch1 -p1 -b .makej
%patch2 -p1 -b .nomulti
%patch3 -p1 -b .compile
%patch4 -p1 -b .awtcolor
%patch5 -p1 -b .sigaction
%patch6 -p0 -b .boehmgc
%patch7 -p0 -b .libdeps

%build
rm -fr obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc64
OPT_FLAGS=-O0
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" \
	../configure --prefix %{_prefix} \
	--enable-shared --enable-threads=posix --host=%{_target_platform}
%make
cd ..

for i in boehm-gc/ChangeLog libjava/ChangeLog zlib/ChangeLog libffi/ChangeLog; do
	cp -p $i ChangeLog.`echo $i | sed 's|/.*||'`
done
cp -p libffi/LICENSE LICENSE.libffi
cp -p libffi/README README.libffi

%install
rm -fr $RPM_BUILD_ROOT

cd obj-%{_target_platform}
make prefix=$RPM_BUILD_ROOT%{_prefix} install
gcjspecdir=`gcc -v 2>&1 >/dev/null | sed -n 's_^.*%{_prefix}/lib/gcc-lib\(.*\)/specs_%{_prefix}/lib/gcc-lib\1_p'`
mkdir -p $RPM_BUILD_ROOT$gcjspecdir/include
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $RPM_BUILD_ROOT$gcjspecdir/libgcj.spec
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libgcj*.a $RPM_BUILD_ROOT$gcjspecdir/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/j*.h $RPM_BUILD_ROOT$gcjspecdir/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,gnu,gcj} $RPM_BUILD_ROOT$gcjspecdir/include/
(cd $RPM_BUILD_ROOT$gcjspecdir;
	ln -sf ../../../libgcj.so.1.* libgcj.so
	ln -sf ../../../libgcjgc.so.1.* libgcjgc.so
)

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_prefix}/bin/jv-convert
%{_prefix}/bin/gij
%{_prefix}/%{_lib}/lib*gcj*.so.*
%{_prefix}/share/libgcj.zip
%doc ChangeLog* LICENSE.libffi README.libffi

%files devel
%defattr(-,root,root)
#
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcj.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcj.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcjgc.a
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcjgc.so
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/libgcj.spec
#
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/jni.h
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/jvmpi.h
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gcj
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gcj/*.h
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gnu
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/gnu/*
%dir %{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/java
%{_libdir}/gcc-lib/%{gcc_target_platform}/%{version}/include/java/*

%changelog
* Tue Jul 31 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.96-4mdk
- Add BuildRequires: gcc-{java,c++} >= 2.96-0.60mdk
- Merge with Red Hat rel26:
  - update to latest boehm-gc
  - move so that it can coexist with libgcj3.0
  - fix shared lib dependencies

* Fri Jul  6 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.96-3mdk
- Merge with Red Hat rel25

* Sun Mar 25 2001 David BAUDENS <baudens@mandrakesoft.com> 2.96-2mdk
- ExcludeArch: ppc
- BuildRequiers: gcc-java

* Sat Mar 10 2001 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.96-1mdk
- First mandrake version.
